// Prime95Doc.cpp : implementation of the CPrime95Doc class
//

#include "stdafx.h"
#include "MainFrm.h"
#include "Prime95.h"
#include "Prime95Doc.h"

#include "math.h"

#include "AffinityDlg.h"
#include "CpuDlg.h"
#include "ClearPrimes.h"
#include "EcmDlg.h"
#include "FactorDlg.h"
#include "ManualCommDlg.h"
#include "Password.h"
#include "PreferencesDlg.h"
#include "PrimeNetDlg.h"
#include "Priority.h"
#include "RangeDlg.h"
#include "ServerDlg.h"
#include "TestDlg.h"
#include "TimeDlg.h"
#include "UserDlg.h"
#include "VacationDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define OP_CONTINUE	1
#define OP_TIME		2
#define OP_SIEVE	3
#define OP_SELFTEST	4
#define OP_TORTURE	5
struct thread_info {
	int	op;		// Opcode defined above
	unsigned long p;	// Prime to test
	unsigned long p2;	// End prime
	unsigned short b1;	// Start # bits
	unsigned short b2;	// End # bits
	int	db;		// Search DB
	CPrime95Doc *doc;	// Ptr to main document
} thread_pkt;
HANDLE	CURRENT_THREAD = 0;

/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc

IMPLEMENT_DYNCREATE(CPrime95Doc, CDocument)

BEGIN_MESSAGE_MAP(CPrime95Doc, CDocument)
	//{{AFX_MSG_MAP(CPrime95Doc)
	ON_COMMAND(IDM_CONTINUE, OnContinue)
	ON_UPDATE_COMMAND_UI(IDM_CONTINUE, OnUpdateContinue)
	ON_COMMAND(IDM_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(IDM_STOP, OnUpdateStop)
	ON_COMMAND(IDM_ERRCHK, OnErrchk)
	ON_UPDATE_COMMAND_UI(IDM_ERRCHK, OnUpdateErrchk)
	ON_COMMAND(IDM_RANGE, OnRange)
	ON_UPDATE_COMMAND_UI(IDM_RANGE, OnUpdateRange)
	ON_COMMAND(IDM_CLEAR_PRIMES, OnClearPrimes)
	ON_COMMAND(IDM_CPU, OnCpu)
	ON_COMMAND(IDM_FACTOR, OnFactor)
	ON_UPDATE_COMMAND_UI(IDM_FACTOR, OnUpdateFactor)
	ON_COMMAND(IDM_PREFERENCES, OnPreferences)
	ON_UPDATE_COMMAND_UI(IDM_TEST, OnUpdateTest)
	ON_COMMAND(IDM_TEST, OnTest)
	ON_UPDATE_COMMAND_UI(IDM_TIME, OnUpdateTime)
	ON_COMMAND(IDM_TIME, OnTime)
	ON_COMMAND(ID_RANGE_STATUS, OnRangeStatus)
	ON_COMMAND(ID_OPTIONS_SELFTEST, OnOptionsSelftest)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SELFTEST, OnUpdateOptionsSelftest)
	ON_UPDATE_COMMAND_UI(IDM_CLEAR_PRIMES, OnUpdateClearPrimes)
	ON_COMMAND(IDM_PASSWORD, OnPassword)
	ON_UPDATE_COMMAND_UI(IDM_PASSWORD, OnUpdatePassword)
	ON_UPDATE_COMMAND_UI(ID_HELP_FINDER, OnUpdateHelpFinder)
	ON_COMMAND(IDM_TRAY, OnTray)
	ON_UPDATE_COMMAND_UI(IDM_TRAY, OnUpdateTray)
	ON_COMMAND(IDM_HIDE, OnHide)
	ON_UPDATE_COMMAND_UI(IDM_HIDE, OnUpdateHide)
	ON_COMMAND(IDM_TORTURE, OnTorture)
	ON_UPDATE_COMMAND_UI(IDM_TORTURE, OnUpdateTorture)
	ON_COMMAND(ID_RANGE_USERINFORMATION, OnRangeUserinformation)
	ON_COMMAND(IDM_PRIMENET, OnPrimenet)
	ON_COMMAND(IDM_PRIORITY, OnPriority)
	ON_UPDATE_COMMAND_UI(IDM_PRIORITY, OnUpdatePriority)
	ON_COMMAND(IDM_SERVER, OnServer)
	ON_UPDATE_COMMAND_UI(IDM_SERVER, OnUpdateServer)
	ON_COMMAND(IDM_QUIT, OnQuitGimps)
	ON_COMMAND(IDM_VACATION, OnVacation)
	ON_COMMAND(IDM_SERVICE, OnService)
	ON_UPDATE_COMMAND_UI(IDM_SERVICE, OnUpdateService)
	ON_COMMAND(ID_MANUALCOMM, OnManualcomm)
	ON_UPDATE_COMMAND_UI(ID_MANUALCOMM, OnUpdateManualcomm)
	ON_UPDATE_COMMAND_UI(ID_RANGE_USERINFORMATION, OnUpdateRangeUserinformation)
	ON_COMMAND(IDM_ECM, OnEcm)
	ON_UPDATE_COMMAND_UI(IDM_ECM, OnUpdateEcm)
	ON_COMMAND(IDM_AFFINITY, OnAffinity)
	ON_UPDATE_COMMAND_UI(IDM_AFFINITY, OnUpdateAffinity)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc construction/destruction

CPrime95Doc *OUTPUT_STR_HACK;

CPrime95Doc::CPrime95Doc()
{
	OUTPUT_STR_HACK = this;
}

CPrime95Doc::~CPrime95Doc()
{
	int	x;
	for (x = 0; x < NumLines; x++)
		if (lines[x] != NULL) free (lines[x]);
}

BOOL CPrime95Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc serialization

void CPrime95Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc diagnostics

#ifdef _DEBUG
void CPrime95Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPrime95Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc commands

void CPrime95Doc::OnCloseDocument() 
{

// Stop background thread before exiting

	if (THREAD_ACTIVE) {
		OnStop ();
		while (THREAD_STOP) Sleep (50);
	}

// Remember the main window's size and position

	CWinApp* pApp = AfxGetApp();
	WINDOWPLACEMENT wp;
	if (pApp->m_pMainWnd) {
		pApp->m_pMainWnd->GetWindowPlacement (&wp);
		IniWriteInt (INI_FILE, "Left", wp.rcNormalPosition.left);
		IniWriteInt (INI_FILE, "Top", wp.rcNormalPosition.top);
		IniWriteInt (INI_FILE, "Right", wp.rcNormalPosition.right);
		IniWriteInt (INI_FILE, "Bottom", wp.rcNormalPosition.bottom);
	}

// Free the networking library

	if (HLIB) FreeLibrary (HLIB);

// Finish closing

	CDocument::OnCloseDocument();
}

// Range menu


void CPrime95Doc::OnPrimenet() 
{
	PrimenetDlg dlg;
	short	work_pref;

	dlg.m_primenet = USE_PRIMENET;
	dlg.m_dialup = DIAL_UP;
	dlg.m_rpc = USE_HTTP;
	dlg.m_work = DAYS_OF_WORK;
	if (WORK_PREFERENCE == 0) {
		dlg.m_work_dflt = 1;
		work_pref = default_work_type ();
	} else {
		dlg.m_work_dflt = 0;
		work_pref = WORK_PREFERENCE;
	}
	dlg.m_lucas = !! (work_pref & PRIMENET_ASSIGN_TEST);
	dlg.m_factor = !! (work_pref & PRIMENET_ASSIGN_FACTOR);
	dlg.m_dblchk = !! (work_pref & PRIMENET_ASSIGN_DBLCHK);
	dlg.m_new_dates = 0;

	if (dlg.DoModal () == IDOK) {
		if (!USE_PRIMENET && dlg.m_primenet) {
			USE_PRIMENET = 1;
			spoolMessage (PRIMENET_MAINTAIN_USER_INFO, NULL);
			spoolMessage (PRIMENET_SET_COMPUTER_INFO, NULL);
			spoolExistingResultsFile ();
		}
		USE_PRIMENET = dlg.m_primenet;
		DIAL_UP = dlg.m_dialup;
		USE_HTTP = dlg.m_rpc;
		DAYS_OF_WORK = dlg.m_work;
		if (dlg.m_work_dflt)
			WORK_PREFERENCE = 0;
		else
			WORK_PREFERENCE =
				(dlg.m_lucas ? PRIMENET_ASSIGN_TEST : 0) +
				(dlg.m_factor ? PRIMENET_ASSIGN_FACTOR : 0) +
				(dlg.m_dblchk ? PRIMENET_ASSIGN_DBLCHK : 0);
		IniWriteInt (INI_FILE, "UsePrimenet", USE_PRIMENET);
		IniWriteInt (INI_FILE, "DialUp", DIAL_UP);
		IniWriteInt (INI_FILE, "UseHTTP", USE_HTTP);
		IniWriteInt (INI_FILE, "DaysOfWork", DAYS_OF_WORK);
		IniWriteInt (INI_FILE, "WorkPreference", WORK_PREFERENCE);
		if (dlg.m_new_dates) UpdateEndDates ();
		CHECK_WORK_QUEUE = 1;
		if (!THREAD_ACTIVE &&
		    (STARTUP_IN_PROGRESS || USE_PRIMENET)) {
			STARTUP_IN_PROGRESS = 0;
			OnContinue ();
		}
	} else
		STARTUP_IN_PROGRESS = 0;
}


void CPrime95Doc::OnUpdateRange(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (! USE_PRIMENET);
}

void CPrime95Doc::OnRange() 
{
	CRangeDlg dlg;
	short	work_preference;

	dlg.m_start = 0;
	dlg.m_end = 0;
	work_preference = default_work_type ();
	if (work_preference == PRIMENET_ASSIGN_TEST) dlg.m_work = 0;
	else dlg.m_work = 1;
	if (dlg.DoModal () == IDOK) {
		getWorkFromDatabase (dlg.m_start, dlg.m_end, dlg.m_work == 1, dlg.m_work == 2);
		rangeStatus ();
		if (!THREAD_ACTIVE) OnContinue ();
	}
}

void CPrime95Doc::OnQuitGimps() 
{
	if (!USE_PRIMENET) {
		if (AfxMessageBox (MANUAL_QUIT, MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES) {
			writeResults ("Quitting GIMPS.\n");
			IniDeleteAllLines (WORKTODO_FILE);
			THREAD_STOP = 1;
			GIMPS_QUIT = 1;
		}
	} else {
		if (AfxMessageBox (PRIMENET_QUIT, MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) == IDYES) {
			writeResults ("Quitting GIMPS.\n");
			spoolMessage (999, NULL);
			if (!THREAD_ACTIVE) OnContinue ();
		}
	}
}

void CPrime95Doc::OnUpdateRangeUserinformation(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (! IniGetInt (INI_FILE, "LockUserInfo", 0));
}

void CPrime95Doc::OnRangeUserinformation() 
{
	CUserDlg dlg;

	dlg.m_name = USER_NAME;
	dlg.m_email = USER_ADDR;
	dlg.m_sendemail = SEND_EMAIL;
	dlg.m_userid = USERID;
	dlg.m_password = USER_PWD;
	dlg.m_compid = COMPID;
	if (dlg.DoModal () == IDOK) {
		if (strcmp (COMPID, dlg.m_compid) != 0) {
			strcpy (COMPID, dlg.m_compid);
			sanitizeString (COMPID);
			IniWriteString (LOCALINI_FILE, "ComputerID", COMPID);
			spoolMessage (PRIMENET_SET_COMPUTER_INFO, NULL);
		}
		if (OLD_USERID[0] == 0 &&
		    strcmp (USERID, dlg.m_userid) != 0) {
			strcpy (OLD_USERID, USERID);
			strcpy (OLD_USER_PWD, USER_PWD);
			IniWriteString (INI_FILE, "OldUserID", OLD_USERID);
			IniWriteString (INI_FILE, "OldUserPWD", OLD_USER_PWD);
		}
		strcpy (USER_PWD, dlg.m_password);
		sanitizeString (USER_PWD);
		IniWriteString (INI_FILE, "UserPWD", USER_PWD);
		if (strcmp (USER_NAME, dlg.m_name) != 0 ||
		    strcmp (USER_ADDR, dlg.m_email) != 0 ||
		    SEND_EMAIL != dlg.m_sendemail ||
		    strcmp (USERID, dlg.m_userid) != 0) {
			strcpy (USER_NAME, dlg.m_name);
			strcpy (USER_ADDR, dlg.m_email);
			SEND_EMAIL = dlg.m_sendemail;
			strcpy (USERID, dlg.m_userid);
			sanitizeString (USERID);
			IniWriteString (INI_FILE, "UserName", USER_NAME);
			IniWriteString (INI_FILE, "UserEmailAddr", USER_ADDR);
			IniWriteInt (INI_FILE, "SendEmail", SEND_EMAIL);
			IniWriteString (INI_FILE, "UserID", USERID);
			spoolMessage (PRIMENET_MAINTAIN_USER_INFO, NULL);
		}
		if (STARTUP_IN_PROGRESS) OnCpu ();
	} else
		STARTUP_IN_PROGRESS = 0;
}

void CPrime95Doc::OnVacation() 
{
	CVacationDlg dlg;

	dlg.m_vacation_days =
		(secondsUntilVacationEnds () + 43200) / 86400;
	dlg.m_computer_on = ON_DURING_VACATION;
	if (dlg.DoModal () == IDOK) {
		if (dlg.m_vacation_days) {
			time (&VACATION_END);
			VACATION_END += dlg.m_vacation_days * 86400;
		} else
			VACATION_END = 0;
		ON_DURING_VACATION = dlg.m_computer_on;
                IniWriteInt (LOCALINI_FILE, "VacationEnd", VACATION_END);
                IniWriteInt (LOCALINI_FILE, "VacationOn", ON_DURING_VACATION);
		if (VACATION_END && !ON_DURING_VACATION)
			IniWriteInt (LOCALINI_FILE, "RollingStartTime", 0);
		UpdateEndDates ();
	}
}

void CPrime95Doc::OnRangeStatus() 
{
	rangeStatus ();
}

void CPrime95Doc::OnUpdateContinue(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (! THREAD_ACTIVE);
}

void CPrime95Doc::OnContinue() 
{
	CWinThread *thread;
	thread_pkt.op = OP_CONTINUE;
	thread_pkt.doc = this;
	thread = AfxBeginThread (threadDispatch, NULL);
}

void CPrime95Doc::OnUpdateStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (THREAD_ACTIVE && !THREAD_STOP);
}

void CPrime95Doc::OnStop() 
{
	THREAD_STOP = 1;
	SetPriorityClass (GetCurrentProcess (), NORMAL_PRIORITY_CLASS);
	SetThreadPriority (CURRENT_THREAD, THREAD_PRIORITY_ABOVE_NORMAL);
}

// Advanced Menu

void CPrime95Doc::OnUpdatePassword(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (!ADVANCED_ENABLED);
}

void CPrime95Doc::OnPassword() 
{
	Password dlg;

	dlg.m_password = 0;
	if (dlg.DoModal () == IDOK) {
		if (dlg.m_password == 9876) {	// secret code
			ADVANCED_ENABLED = 1;
			IniWriteInt (INI_FILE, "Advanced", 1);
			return;
		}
	}
}

void CPrime95Doc::OnUpdateTest(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED && ! THREAD_ACTIVE);
}

void CPrime95Doc::OnTest() 
{
	CTestDlg dlg;

	if (dlg.DoModal () == IDOK) {
		IniFileOpen (WORKTODO_FILE, 1);
		IniInsertLineAsInt (WORKTODO_FILE, 1, "AdvancedTest", dlg.m_p);
		OnContinue ();
	}
}

void CPrime95Doc::OnUpdateTime(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED && ! THREAD_ACTIVE);
}

void CPrime95Doc::OnTime() 
{
	CTimeDlg dlg;

	dlg.m_p = 900000;
	dlg.m_iter = 10;
	if (dlg.DoModal () == IDOK) {
		thread_pkt.op = OP_TIME;
		thread_pkt.p = dlg.m_p;
		thread_pkt.p2 = dlg.m_iter;
		thread_pkt.doc = this;
		CWinThread *thread = AfxBeginThread (threadDispatch, NULL);
	}
}

void CPrime95Doc::OnUpdateClearPrimes(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED);
}

void CPrime95Doc::OnClearPrimes() 
{
	CClearPrimes dlg;

	if (dlg.DoModal () == IDOK) {
		clearExponents (dlg.m_p1, dlg.m_p2, 0);
	}
}

void CPrime95Doc::OnUpdateFactor(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED && ! THREAD_ACTIVE);
}

void CPrime95Doc::OnFactor() 
{
	CFactorDlg dlg;

	dlg.m_b1 = 1;
	dlg.m_b2 = 48;
	if (dlg.DoModal () == IDOK) {
		thread_pkt.op = OP_SIEVE;
		thread_pkt.p = dlg.m_p1;
		thread_pkt.p2 = dlg.m_p2;
		thread_pkt.b1 = dlg.m_b1;
		thread_pkt.b2 = dlg.m_b2;
		thread_pkt.db = dlg.m_db;
		thread_pkt.doc = this;
		CWinThread *thread = AfxBeginThread (threadDispatch, NULL);
	}
}

void CPrime95Doc::OnUpdateEcm(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED && ! THREAD_ACTIVE);
}

void CPrime95Doc::OnEcm() 
{
	CEcmDlg dlg;

	dlg.m_bound1 = 1000000;
	dlg.m_num_curves = 100;
	if (dlg.DoModal () == IDOK) {
		work_unit w;
		w.work_type = WORK_ECM;
		w.p = dlg.m_p;
		w.B1 = dlg.m_bound1;
		w.B2 = dlg.m_bound2;
		w.curves_to_do = dlg.m_num_curves;
		w.curves_completed = 0;
		w.curve = dlg.m_curve;
		addWorkToDoLine (&w);
		OnContinue ();
	}
}

void CPrime95Doc::OnUpdateErrchk(CCmdUI* pCmdUI) 
{
	int	echk = IniGetInt (INI_FILE, "ErrorCheck", 0);
	pCmdUI->SetCheck (echk);
	pCmdUI->Enable (ADVANCED_ENABLED);
}

void CPrime95Doc::OnErrchk() 
{
	int	echk = IniGetInt (INI_FILE, "ErrorCheck", 0);
	echk = !echk;
	IniWriteInt (INI_FILE, "ErrorCheck", echk);
	if (echk) ERRCHK++; else ERRCHK--;
}

void CPrime95Doc::OnUpdatePriority(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (!THREAD_ACTIVE && ADVANCED_ENABLED);
}

void CPrime95Doc::OnPriority() 
{
	CPriority dlg;

	dlg.m_priority = PRIORITY;
	if (dlg.DoModal () == IDOK) {
		if (PRIORITY != dlg.m_priority) {
			PRIORITY = dlg.m_priority;
			IniWriteInt (INI_FILE, "Priority", PRIORITY);
		}
	}
}

void CPrime95Doc::OnUpdateAffinity(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (!isWindows95 ());
}

void CPrime95Doc::OnAffinity() 
{
	CAffinityDlg dlg;

	if (CPU_AFFINITY == 99) {
		dlg.m_all_cpus = 1;
		dlg.m_cpu = 0;
	} else {
		dlg.m_all_cpus = 0;
		dlg.m_cpu = CPU_AFFINITY;
	}
	if (dlg.DoModal () == IDOK) {
		if (dlg.m_all_cpus) CPU_AFFINITY = 99;
		else CPU_AFFINITY = dlg.m_cpu;
		IniWriteInt (INI_FILE, "Affinity", CPU_AFFINITY);
	}
}

void CPrime95Doc::OnUpdateManualcomm(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED && USE_PRIMENET);
}

void CPrime95Doc::OnManualcomm() 
{
	CManualCommDlg dlg;

	dlg.m_manual_comm = MANUAL_COMM & 0x1;
	dlg.m_comm_now = 1;
	if (dlg.DoModal () == IDOK) {
		MANUAL_COMM = dlg.m_manual_comm;
		IniWriteInt (INI_FILE, "ManualComm", MANUAL_COMM);
		if (dlg.m_comm_now) {
			MANUAL_COMM |= 0x2;
			CHECK_WORK_QUEUE = 1;
			if (!THREAD_ACTIVE) OnContinue ();
		}
	}
}


// Options menu

void CPrime95Doc::OnCpu() 
{
	CCpuDlg dlg;

	dlg.m_speed = CPU_SPEED;
	dlg.m_cpu_type =
		(CPU_TYPE == 3) ? 0 : (CPU_TYPE == 4) ? 1 :
		(CPU_TYPE == 5) ? 3 : (CPU_TYPE == 6) ? 4 : 2;
	dlg.m_hours = CPU_HOURS;
	if (dlg.DoModal () == IDOK) {
		unsigned int new_cpu_type;

		new_cpu_type = (dlg.m_cpu_type == 0) ? 3 :
			       (dlg.m_cpu_type == 1) ? 4 :
			       (dlg.m_cpu_type == 3) ? 5 :
			       (dlg.m_cpu_type == 4) ? 6 : 7;
		if (CPU_SPEED != dlg.m_speed ||
		    CPU_TYPE != new_cpu_type ||
		    CPU_HOURS != dlg.m_hours) {
			ROLLING_AVERAGE = 1000;
			IniWriteInt (LOCALINI_FILE, "RollingAverage", 1000);
			IniWriteInt (LOCALINI_FILE, "RollingStartTime", 0);
			spoolMessage (PRIMENET_SET_COMPUTER_INFO, NULL);
			UpdateEndDates ();
		}
		CPU_SPEED = dlg.m_speed;
		CPU_TYPE = new_cpu_type;
		CPU_HOURS = dlg.m_hours;
		IniWriteInt (LOCALINI_FILE, "CPUType", CPU_TYPE);
		IniWriteInt (LOCALINI_FILE, "CPUSpeed", CPU_SPEED);
		IniWriteInt (LOCALINI_FILE, "CPUHours", CPU_HOURS);
		if (STARTUP_IN_PROGRESS) OnPrimenet ();
	} else
		STARTUP_IN_PROGRESS = 0;
}

void CPrime95Doc::OnPreferences() 
{
	CPreferencesDlg dlg;

	dlg.m_iter = ITER_OUTPUT;
	dlg.m_r_iter = ITER_OUTPUT_RES;
	dlg.m_disk_write_time = DISK_WRITE_TIME;
	dlg.m_modem = MODEM_RETRY_TIME;
	dlg.m_retry = NETWORK_RETRY_TIME;
	dlg.m_end_dates = DAYS_BETWEEN_CHECKINS;
	dlg.m_backup = TWO_BACKUP_FILES;
	dlg.m_noise = !SILENT_VICTORY;
	if (dlg.DoModal () == IDOK) {
		ITER_OUTPUT = dlg.m_iter;
		ITER_OUTPUT_RES = dlg.m_r_iter;
		DISK_WRITE_TIME = dlg.m_disk_write_time;
		MODEM_RETRY_TIME = dlg.m_modem;
		NETWORK_RETRY_TIME = dlg.m_retry;
		DAYS_BETWEEN_CHECKINS = dlg.m_end_dates;
		TWO_BACKUP_FILES = dlg.m_backup;
		SILENT_VICTORY = !dlg.m_noise;
		IniWriteInt (INI_FILE, "OutputIterations", ITER_OUTPUT);
		IniWriteInt (INI_FILE, "ResultsFileIterations", ITER_OUTPUT_RES);
		IniWriteInt (INI_FILE, "DiskWriteTime", DISK_WRITE_TIME);
		IniWriteInt (INI_FILE, "NetworkRetryTime", MODEM_RETRY_TIME);
		IniWriteInt (INI_FILE, "NetworkRetryTime2", NETWORK_RETRY_TIME);
		IniWriteInt (INI_FILE, "DaysBetweenCheckins", DAYS_BETWEEN_CHECKINS);
		IniWriteInt (INI_FILE, "TwoBackupFiles", TWO_BACKUP_FILES);
		IniWriteInt (INI_FILE, "SilentVictory", SILENT_VICTORY);
	}
}

void CPrime95Doc::OnUpdateOptionsSelftest(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (! THREAD_ACTIVE);
}

void CPrime95Doc::OnOptionsSelftest() 
{
	CWinThread *thread;
	thread_pkt.op = OP_SELFTEST;
	thread_pkt.doc = this;
	thread = AfxBeginThread (threadDispatch, NULL);
}

void CPrime95Doc::OnUpdateTorture(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (! THREAD_ACTIVE);
}

void CPrime95Doc::OnTorture() 
{
	CWinThread *thread;
	thread_pkt.op = OP_TORTURE;
	thread_pkt.doc = this;
	thread = AfxBeginThread (threadDispatch, NULL);
}

void CPrime95Doc::OnUpdateTray(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck (TRAY_ICON);
}

void CPrime95Doc::OnTray() 
{
	CPrime95App* pApp = (CPrime95App *) AfxGetApp();
	TRAY_ICON = ! TRAY_ICON;
	if (TRAY_ICON) {
		HIDE_ICON = 0;
		pApp->TrayMessage (NIM_ADD, NULL);
	} else {
		pApp->TrayMessage (NIM_DELETE, NULL);
	}
	IniWriteInt (INI_FILE, "HideIcon", HIDE_ICON);
	IniWriteInt (INI_FILE, "TrayIcon", TRAY_ICON);
}

void CPrime95Doc::OnUpdateHide(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (ADVANCED_ENABLED);
	pCmdUI->SetCheck (HIDE_ICON);
}

void CPrime95Doc::OnHide() 
{
	CPrime95App* pApp = (CPrime95App *) AfxGetApp();
#define HIDEWARN "WARNING: It is recommended that you create a shortcut to prime95.exe and define a shortcut key.  If you do not do this you will be unable to activate prime95 once you minimize it."

	HIDE_ICON = ! HIDE_ICON;
	if (HIDE_ICON) {
		if (TRAY_ICON) pApp->TrayMessage (NIM_DELETE, NULL);
		TRAY_ICON = 0;
		AfxMessageBox (HIDEWARN, MB_ICONINFORMATION);
//Neither of the below worked - I don't know why
//RegisterHotKey(pApp->m_pMainWnd->m_hWnd,0x3852,MOD_CONTROL+MOD_ALT,'M');
//pApp->m_pMainWnd->SendMessage (WM_SETHOTKEY,
//			       (WPARAM) MAKEWORD('M', HOTKEYF_CONTROL + HOTKEYF_ALT), 0);
	}
	IniWriteInt (INI_FILE, "HideIcon", HIDE_ICON);
	IniWriteInt (INI_FILE, "TrayIcon", TRAY_ICON);
}

void CPrime95Doc::OnUpdateService(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (isWindows95 ());
	pCmdUI->SetCheck (WINDOWS95_SERVICE);
}

void CPrime95Doc::OnService() 
{
	WINDOWS95_SERVICE = !WINDOWS95_SERVICE;
	IniWriteInt (INI_FILE, "Windows95Service", WINDOWS95_SERVICE);
	Service95 ();
}


// Help menu


void CPrime95Doc::OnUpdateHelpFinder(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (FALSE);
}

void CPrime95Doc::OnUpdateServer(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (USE_PRIMENET);
}

void CPrime95Doc::OnServer() 
{
	CServerDlg dlg;
	struct primenetPingServerInfo pkt;
	
	if (sendMessage (PRIMENET_PING_SERVER_INFO, &pkt)) {
		AfxMessageBox (PING_ERROR, MB_OK | MB_ICONEXCLAMATION);
	} else {
		dlg.m_line1 = pkt.buildID;
		dlg.m_line2 = pkt.primenetServerName;
		dlg.m_line3 = pkt.adminEmailAddr;
		dlg.DoModal ();
	}
}


/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc private routines

void CPrime95Doc::LineFeed ()
{
	char	*p;

// Scroll the line on the screen

	p = lines[NumLines-1];
	memmove (&lines[1], &lines[0], (NumLines-1)*sizeof(char *));
	lines[0] = p;
	*p = 0;
	UpdateAllViews (NULL);
}

void OutputStr (char *str)
{
	OUTPUT_STR_HACK->OutputStr (str);
}

void title (char *str)
{
	OUTPUT_STR_HACK->title (str);
}

void flashWindowAndBeep ()
{
	CWinApp* pApp = AfxGetApp();
	pApp->m_pMainWnd->FlashWindow (TRUE);
	MessageBeep (0xFFFFFFFF);
}

void CPrime95Doc::OutputStr (
	char	*str)
{
	if (lines[0] == NULL) {
		for (int i = 0; i < NumLines; i++) {
			lines[i] = (char *) malloc (128);
			*lines[i] = 0;
		}
	}
	char *p = lines[0] + strlen (lines[0]);
	for ( ; *str; str++) {
		if (*str == '\n') *p = 0, LineFeed (), p = lines[0];
		else *p++ = *str;
	}
	*p = 0;
}


/////////////////////////////////////////////////////////////////////////////
// CPrime95Doc public routines

#include <ctype.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cpuid.c"
#include "speed.c"

#define PORT	1
#include "commona.c"
#include "commonb.c"
#include "commonc.c"
#include "ecm.c"
#include "comm95a.c"
#include "comm95b.c"
#include "comm95c.c"

UINT threadDispatch (
	LPVOID stuff)
{

// Set thread-active flags

	THREAD_ACTIVE = TRUE;
	THREAD_STOP = 0;

// Set the priority correctly

	SetPriorityClass (GetCurrentProcess (),
		(PRIORITY < 2 || PRIORITY > 6) ?
			NORMAL_PRIORITY_CLASS :
			IDLE_PRIORITY_CLASS);
	CURRENT_THREAD = GetCurrentThread ();
	SetThreadPriority (CURRENT_THREAD,
		(PRIORITY == 1) ? THREAD_PRIORITY_IDLE :
		(PRIORITY == 2 || PRIORITY == 7) ? THREAD_PRIORITY_LOWEST :
		(PRIORITY == 3 || PRIORITY == 8) ? THREAD_PRIORITY_BELOW_NORMAL :
		(PRIORITY == 4 || PRIORITY == 9) ? THREAD_PRIORITY_NORMAL :
		(PRIORITY == 5 || PRIORITY == 10) ? THREAD_PRIORITY_ABOVE_NORMAL :
		THREAD_PRIORITY_HIGHEST);
	if (CPU_AFFINITY != 99 && !isWindows95 ())
		SetThreadAffinityMask (CURRENT_THREAD, 1 << CPU_AFFINITY);

// Dispatch to the correct code

	switch (thread_pkt.op) {
	case OP_CONTINUE:
		primeContinue ();
		break;
	case OP_TIME:
		primeTime (thread_pkt.p, thread_pkt.p2);
		break;
	case OP_SIEVE:
		primeSieve (thread_pkt.p, thread_pkt.p2,
			    thread_pkt.b1, thread_pkt.b2,
			    thread_pkt.db, 0);
		break;
	case OP_SELFTEST:
		selfTest (0);
		break;
	case OP_TORTURE:
		selfTest (1);
		break;
	}

// Free memory used in the assembly code

	freeMem ();

// Output informative message

	if (!GIMPS_QUIT) {
		OutputStr ("Execution halted.\n");
		OutputStr ("Choose Test/Continue to restart.\n");
	}

// Clear thread-active flags

	THREAD_ACTIVE = FALSE;
	THREAD_STOP = 0;
	title ("IDLE");

// Abort program if time is up

	if (timeCheck ())
		AfxGetApp()->m_pMainWnd->PostMessage (WM_QUIT);

// Thread complete

	return (0);
}


/* Return TRUE if we should stop calculating */

int escapeCheck ()
{
	return (THREAD_STOP);
}

/* Put a title on the main window */

void CPrime95Doc::title (
	char	*str)
{
	char buf[80];
	CWinApp* pApp = AfxGetApp();
static	int was_iconic = TRUE;

	sprintf (buf, "Prime95 - %s", str);
	if (pApp->m_pMainWnd) {
		if (TRAY_ICON)
			((CPrime95App *)pApp)->
				TrayMessage (NIM_MODIFY, buf);
		if (pApp->m_pMainWnd->IsIconic ()) {
			pApp->m_pMainWnd->SetWindowText (buf);
			was_iconic = TRUE;
		} else if (was_iconic) {
			pApp->m_pMainWnd->SetWindowText ("Prime95");
			was_iconic = FALSE;
		}
	}
}

// Output a status report for the range

void CPrime95Doc::rangeStatus ()
{
	char	buf[2000];

	rangeStatusMessage (buf);

	AfxMessageBox (buf, MB_ICONINFORMATION);
}
