/* Last valid address for the various FFT sizes */

#define THE_END_80	(DATA_ADDR+0xEBF00)	/* Max addr for 80K FFT */
#define THE_END_96	(DATA_ADDR+0x117700)	/* Max addr for 96K FFT */
#define THE_END_112	(DATA_ADDR+0x1431C0)	/* Max addr for 112K FFT */
#define THE_END_128	(DATA_ADDR+0x16E9C0)	/* Max addr for 128K FFT */
#define THE_END_160	(DATA_ADDR+0x1C61A0)	/* Max addr for 160K FFT */
#define THE_END_192	(DATA_ADDR+0x21D520)	/* Max addr for 192K FFT */
#define THE_END_224	(DATA_ADDR+0x2748E0)	/* Max addr for 224K FFT */
#define THE_END_256	(DATA_ADDR+0x2CBBC0)	/* Max addr for 256K FFT */
#define THE_END_320	(DATA_ADDR+0x379AA0)	/* Max addr for 320K FFT */
#define THE_END_384	(DATA_ADDR+0x428020)	/* Max addr for 384K FFT */
#define THE_END_448	(DATA_ADDR+0x4D65E0)	/* Max addr for 448K FFT */
#define THE_END_512	(DATA_ADDR+0x584AC0)	/* Max addr for 512K FFT */
#define THE_END_640	(DATA_ADDR+0x6E2800)	/* Max addr for 640K FFT */
#define THE_END_768	(DATA_ADDR+0x83F660)	/* Max addr for 768K FFT */
#define THE_END_896	(DATA_ADDR+0x99C500)	/* Max addr for 896K FFT */
#define THE_END_1024	(DATA_ADDR+0xAF8FC0)	/* Max addr for 1024K FFT */

/* These macros produce the security codes used for sending in results */
/* The security.h file is not required to compile a trial version of */
/* this program. */

#include "security.h"
#ifndef SEC1
#define SEC1(p)		0
#define SEC2(p,hi,lo)	0
#define SEC3(p)		0
#define SEC4(p)		0
#endif


/* Common global variables */

extern int TIMED_RUN;
extern time_t END_TIME;

extern double *ECM_ADDR;		/* Hack for ECM code to use addr func*/
extern long THE_END;			/* End of the used address space */

/* Common routines */

int isKnownMersennePrime (unsigned long);
void clear_memory (unsigned long, unsigned long);
void makestr (unsigned long, unsigned long, char *buf);
void generateResidue64 (unsigned long, unsigned long, unsigned long *,
			unsigned long *);
long addr (unsigned long, unsigned long, unsigned long);
int is_big_word (unsigned long, unsigned long, unsigned long);

int writeToFile (unsigned long, char *, unsigned long, unsigned long);
int readFileData (int, unsigned long, unsigned long);

void primeContinue ();
int prime (unsigned long, unsigned long, unsigned long);
int selfTest (unsigned long);
int selfTestInternal (unsigned long, int);
void primeTime (unsigned long, unsigned long);
int primeFactor (unsigned long, unsigned int, int *, int, int);
int primeSieve (unsigned long, unsigned long, unsigned short,
		unsigned short, short, int);
void primeSieveTest ();

/* Routines called by common routines */

void title (char *);
void flashWindowAndBeep ();
void get_fft_value (unsigned long, unsigned long, unsigned long, long *);
void set_fft_value (unsigned long, unsigned long, unsigned long, long);
int ecm (unsigned long, unsigned long, unsigned long, unsigned long,
	  unsigned long, double);
