// Prime95.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Prime95.h"

#include "MainFrm.h"
#include "Prime95Doc.h"
#include "Prime95View.h"

#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrime95App

BEGIN_MESSAGE_MAP(CPrime95App, CWinApp)
	//{{AFX_MSG_MAP(CPrime95App)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrime95App construction

CPrime95App::CPrime95App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPrime95App object

CPrime95App theApp;

/////////////////////////////////////////////////////////////////////////////
// CPrime95App initialization

BOOL CPrime95App::InitInstance()
{
	int	named_ini_files = -1;
	char	*p;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	//LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CPrime95Doc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CPrime95View));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

/* Change the working directory to the same directory that */
/* the executable is located.  This is especially important */
/* for running prime95 as a Windows 95 service */

	{
		char	buf[256];
		GetModuleFileName (NULL, buf, sizeof (buf));
		strrchr (buf, '\\')[1] = 0;
		_chdir (buf);
	}

// Process command line switches

	for (p = m_lpCmdLine; *p == '//' || *p == '-'; ) {
		p++;
		switch (*p++) {

// Accept a -A switch indicating an alternate set of INI files
// are to be used.

		case 'A':
		case 'a':
			named_ini_files = 0;
			while (isspace (*p)) p++;
			while (isdigit (*p)) {
				named_ini_files = named_ini_files * 10 + (*p - '0');
				p++;
			}
			break;

// Accept a -W switch indicating an alternate working directory.

		case 'W':
		case 'w':
			{
			char	buf[256];
			char	*bufp = buf;
			while (isspace (*p)) p++;
			while (*p && !isspace (*p)) *bufp++ = *p++;
			*bufp = 0;
			_chdir (buf);
			}
			break;
		}

// Skip whitespace between switches

		while (isspace (*p)) p++;
	}

/* Determine the names of the INI files */

	nameIniFiles (named_ini_files);

/* Copy the old INI file to new style INI files */

	if (! fileExists (INI_FILE) &&
	    ! fileExists (WORKTODO_FILE) &&
	    GetProfileInt (INI_SECTION, "V15CVT", 0) == 0) {
		IniFileOpen (INI_FILE, 0);

		ADVANCED_ENABLED = GetProfileInt (INI_SECTION, "Advanced", 0);
		IniWriteInt (INI_FILE, "Advanced", ADVANCED_ENABLED);

		ERRCHK = GetProfileInt (INI_SECTION, "ErrorCheck", 0);
		IniWriteInt (INI_FILE, "ErrorCheck", ERRCHK);

		CPU_TYPE = GetProfileInt (INI_SECTION, "CPUType", 0);
		CPU_SPEED = GetProfileInt (INI_SECTION, "CPU", 0);
		IniWriteInt (LOCALINI_FILE, "CPUType", CPU_TYPE);
		IniWriteInt (LOCALINI_FILE, "CPUSpeed", CPU_SPEED);

		ITER_OUTPUT = GetProfileInt (INI_SECTION, "OutputIterations", 100);
		IniWriteInt (INI_FILE, "OutputIterations", ITER_OUTPUT);

		HIDE_ICON = GetProfileInt (INI_SECTION, "HideIcon", 0);
		TRAY_ICON = GetProfileInt (INI_SECTION, "TrayIcon", 0);
		IniWriteInt (INI_FILE, "HideIcon", HIDE_ICON);
		IniWriteInt (INI_FILE, "TrayIcon", TRAY_ICON);

		IniWriteInt (LOCALINI_FILE, "SelfTest64Passed",
			     GetProfileInt (INI_SECTION, "SelfTest64Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest80Passed",
			     GetProfileInt (INI_SECTION, "SelfTest80Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest96Passed",
			     GetProfileInt (INI_SECTION, "SelfTest96Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest112Passed",
			     GetProfileInt (INI_SECTION, "SelfTest112Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest128Passed",
			     GetProfileInt (INI_SECTION, "SelfTest128Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest160Passed",
			     GetProfileInt (INI_SECTION, "SelfTest160Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest192Passed",
			     GetProfileInt (INI_SECTION, "SelfTest192Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest224Passed",
			     GetProfileInt (INI_SECTION, "SelfTest224Passed", 0));
		IniWriteInt (LOCALINI_FILE, "SelfTest256Passed",
			     GetProfileInt (INI_SECTION, "SelfTest256Passed", 0));

		IniWriteInt (INI_FILE, "Left",
			     GetProfileInt (INI_SECTION, "Left", 0));
		IniWriteInt (INI_FILE, "Top",
			     GetProfileInt (INI_SECTION, "Top", 0));
		IniWriteInt (INI_FILE, "Right",
			     GetProfileInt (INI_SECTION, "Right", 0));
		IniWriteInt (INI_FILE, "Bottom",
			     GetProfileInt (INI_SECTION, "Bottom", 0));

		if (GetProfileInt (INI_SECTION, "FactorOverride", 0))
			IniWriteInt (INI_FILE, "FactorOverride",
				     GetProfileInt (INI_SECTION, "FactorOverride", 0));

// Copy old range info into work-to-do.ini (including next range).

		unsigned long start, end;
		int	factoring, dblchk;

		factoring = GetProfileInt (INI_SECTION, "OnlyFindFactors", 0);
		dblchk = GetProfileInt (INI_SECTION, "DoubleCheck", 0);
		start = GetProfileInt (INI_SECTION, "RangeStart", 0);
		end = GetProfileInt (INI_SECTION, "RangeEnd", 0);
		if (start) getWorkFromDatabase (start, end, factoring, dblchk);
		start = GetProfileInt (INI_SECTION, "NextRangeStart", 0);
		end = GetProfileInt (INI_SECTION, "NextRangeEnd", 0);
		if (start) getWorkFromDatabase (start, end, factoring, dblchk);

// Send existing results file to the server

		spoolExistingResultsFile ();

// Set INI file entry so that this code will not be executed again

		WriteProfileInt (INI_SECTION, "V15CVT", 1);

// Write out the new ini file

		IniFileClose (INI_FILE);
	}

/* Read new INI file */

	readIniFiles ();

// On first run, get user name and email address
// before contacting server for a work assignment

	if (USE_PRIMENET && USERID[0] == 0) {
		STARTUP_IN_PROGRESS = 1;
		m_pMainWnd->PostMessage (WM_COMMAND, ID_RANGE_USERINFORMATION, 0);
	}

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CPrime95App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CPrime95App commands


/////////////////////////////////////////////////////////////////////////////
// My application-wide stuff went here
/////////////////////////////////////////////////////////////////////////////

char	*lines[NumLines] = {NULL};
int	charHeight = 0;

